/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"fmt"
)

// AdministratorsAccess the model 'AdministratorsAccess'
type AdministratorsAccess string

// List of AdministratorsAccess
const (
	ADMINISTRATORSACCESS_UNDEFINED AdministratorsAccess = "Undefined"
	ADMINISTRATORSACCESS_FULL      AdministratorsAccess = "Full"
	ADMINISTRATORSACCESS_LIMITED   AdministratorsAccess = "Limited"
)

// All allowed values of AdministratorsAccess enum
var AllowedAdministratorsAccessEnumValues = []AdministratorsAccess{
	"Undefined",
	"Full",
	"Limited",
}

func (v *AdministratorsAccess) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := AdministratorsAccess(value)
	for _, existing := range AllowedAdministratorsAccessEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid AdministratorsAccess", value)
}

// NewAdministratorsAccessFromValue returns a pointer to a valid AdministratorsAccess
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewAdministratorsAccessFromValue(v string) (*AdministratorsAccess, error) {
	ev := AdministratorsAccess(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for AdministratorsAccess: valid values are %v", v, AllowedAdministratorsAccessEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v AdministratorsAccess) IsValid() bool {
	for _, existing := range AllowedAdministratorsAccessEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to AdministratorsAccess value
func (v AdministratorsAccess) Ptr() *AdministratorsAccess {
	return &v
}

type NullableAdministratorsAccess struct {
	value *AdministratorsAccess
	isSet bool
}

func (v NullableAdministratorsAccess) Get() *AdministratorsAccess {
	return v.value
}

func (v *NullableAdministratorsAccess) Set(val *AdministratorsAccess) {
	v.value = val
	v.isSet = true
}

func (v NullableAdministratorsAccess) IsSet() bool {
	return v.isSet
}

func (v *NullableAdministratorsAccess) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAdministratorsAccess(val *AdministratorsAccess) *NullableAdministratorsAccess {
	return &NullableAdministratorsAccess{value: val, isSet: true}
}

func (v NullableAdministratorsAccess) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAdministratorsAccess) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
